import { select, 
        json,
        tsv,
        geoMercator,
        geoPath,
        zoom,
        event,
        scaleOrdinal,
        range,
        interpolatePurples,
        polygonCentroid
       } 
from 'd3'; 


import {
 feature
} from 'topojson';
 
const height = 1200;
const width = 1200;

const svg = d3.select('.map').attr('height',height)
                             .attr('width',width);


const selection = svg.append('g')

Promise.all(
  [
   json('https://raw.githubusercontent.com/deldersveld/topojson/master/countries/japan/jp-towns.json')
  ]).then( ([dataRef ]) => {
  
  console.log('jsonfile',dataRef)
  
  const projection = geoMercator().translate([-1200,1000]).scale([1500])
  const pathGen = geoPath(projection)
  
  
  
  const Japan = feature(dataRef,dataRef.objects.JPN_adm2)
  
  const states = Japan.features.map(d => d.properties.NAME_1)
  
  
  const stateF =  scaleOrdinal(states,range(states.length))
  
  console.log('Japan',Japan)
  
  const group = selection.selectAll('g').data(Japan.features).enter().append('g')
  
  const outline =   group.append('path').attr('d',pathGen)
                      			.style("stroke", "#7ac7c4")
                      			.style("fill",d => {  
                      					return interpolatePurples(2.5*stateF(d.properties.NAME_1)/70); })
                      			.style("stroke-width", "2px")
                            .style("opacity","0.3")
  
  // topojson missing Lakshadweep
  
 const names =    group.append('text')
  											.attr('x',d => {
                          
                          if(!isNaN(pathGen.centroid(d)[0]))
                          return pathGen.centroid(d)[0]; 
                          else{
                            console.log('missing',d)
                          }
                                       })
  											.attr('y',d => {
                          if(!isNaN(pathGen.centroid(d)[0]))
                          return pathGen.centroid(d)[1];                  
                                       })
                        .text(d=>d.properties.NAME_1)
});
  


  
 


 
